// Vertex Shader  file "reflection.vert"	

#version 330

uniform mat4 modelViewMatrix;	//model-view matrix
uniform mat4 projectionMatrix;	//projection matrix
uniform vec3 eyePositionWorld;	//eye position in world coordinates
uniform mat4 modelToWorld;		//model to world transformation matrix

in vec4 vertex;		//local coordinates
in vec3 normal;		//local normals
in vec2 texure0;	//texture coordinates

//variables for fragment shader		
out vec4 viewPos;	//view position
out vec2 texCoord0;	//texture coordinates
out vec3 R;			//reflection

void main(void) {
	//original
	viewPos = modelViewMatrix * vertex;
	texCoord0 = texure0;

	vec3 positionWorld = (modelToWorld * vertex).xyz;
	vec3 N = normalize(mat3(modelToWorld) * normal);

	vec3 V = positionWorld - eyePositionWorld;
	R = reflect(V, N);
	
	gl_Position = projectionMatrix * viewPos;
}